﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;

namespace GTDemoService
{
    /// <summary>
    /// Summary description for Service1
    /// </summary>
    [WebService(Namespace = "http://localhost/GTDemoService")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class Service1 : System.Web.Services.WebService
    {
        // Simple Hello World Service method
        [WebMethod]
        public string HelloWorld()
        {
            return "Hello World, this is the service and updated too!";
        }

        // A Web Service method that randomly returns a Quote from the character "Yoda"
        // made famous by the "Star Wars" movie series
        [WebMethod]
        public string YodaQuotes()
        {
            // Create a Random instance
            Random rand = new Random();

            // Hardcoded list of quotes
            String[] quotes = {"Put it on the cloud you must!",
                              "Powerful you have become, the dark side I sense in you",
                              "Grave danger you are in. Impatient you are.",
                              "Try not. Do or do not, there is no try.",
                              "Once you start down the dark path, forever will it dominate your destiny, consume you it will.",
                              "Always in motion is the future.",
                              "Around the survivors a perimeter create.",
                              "Size matters not.",
                              "May the force be with you.",
                              "Blind we are, if creation of this clone army we could not see.",
                              "A Jedi's strength flows from the Force.",
                              "Help you I can, yes.",
                              "Strong am I with the force.",
                              "Agree with you the council does. Your apprentice Skywalker will be.",
                              "Always two there are, no more, no less: a master and an apprentice.",
                              "Lost a planet Master Obi-Wan has. How embarrassing.",
                              "When 900 years you reach, look as good, you will not.",
                              "There... is... another... Sky... walker"
        };
            // Pick a random number as index and return the quote at that index
            int randNum = rand.Next(0, quotes.Length - 1);
            return quotes[randNum];
        }

        // A web service method that, given a bounding box, returns the centroid
        // of that bounding box
        [WebMethod]
        public CloudPoint Centroid(CloudBoundingBox bb)
        {
            CloudPoint centroid = new CloudPoint();
            
            double x=0, y=0, z=0;
            foreach (CloudPoint clPt in bb.pts)
            {
                x += clPt.x;
                y += clPt.y;
                z += clPt.z;
            }

            x = x / bb.pts.Length;
            y = y / bb.pts.Length;
            z = z / bb.pts.Length;

            centroid.x = x;
            centroid.y = y;
            centroid.z = z;

            return centroid;
        }
    }

    // Define data structures necessary for the cloud service
    public struct CloudPoint
    {
        public double x;
        public double y;
        public double z;
    }
    public struct CloudBoundingBox
    {
        public CloudPoint[] pts;
    }
}
