﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using WebRole1.TaskMonitorTableAdapters;


namespace WebRole1
{
    public partial class Summary : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            // Populate the Pie and Bar chart controls with a summary of the number of entities created
            // by each user
            vw_tasksummaryTableAdapter vwSumm = new vw_tasksummaryTableAdapter();
            taskBarChat.Titles.Add("ADN Employee Work Data");
            taskPieChart.Titles.Add("ADN Employee Work Data as a Pie");
            taskPieChart.Series[0]["PieLabelStyle"] = "Inside";
            taskPieChart.ChartAreas[0].Area3DStyle.Enable3D = true;


            taskBarChat.Series[0].Points.DataBind(vwSumm.GetData(), "Name", "EntityCount", null);
            taskPieChart.Series[0].Points.DataBind(vwSumm.GetData(), "Name", "EntityCount", null);

            // Polulate a grid view control with the same summary information
            GridView1.DataSource = vwSumm.GetData();
            GridView1.DataBind();

        }

        protected void taskBarChat_Load(object sender, EventArgs e)
        {

        }

        protected void taskPieChart_Load(object sender, EventArgs e)
        {

        }

        protected void GridView1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        protected void GridView1_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            TableCell tc = new TableCell();
            // Add a button "Encourage" to each row of the Summary Grid view control.
            // When someone clicks the button, a row is added in a table in
            // an Azure SQL Relational Database. This row contains the name of the user
            // against which the button is listed
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                Button encourageButton = new Button()
                {

                    ID = "NormalButtonButton",
                    Text = "Encourage"

                };
                encourageButton.Click += new EventHandler(encourageButton_Click);
                encourageButton.Attributes.Add("Name", e.Row.Cells[0].Text);
                tc.Controls.Add(encourageButton);
            }
            e.Row.Cells.Add(tc);
        }

        void sendMsgButton_Click(object sender, EventArgs e)
        {
            
        }

        void encourageButton_Click(object sender, EventArgs e)
        {
            //throw new NotImplementedException();
            //sender
            // Add a row to the "EncourageMessage" table with the name of the user
            // against which the Encourage button is rendered.
            // The more the number of names is repeated in the table, the stronger
            // the message sent to the user.
            Button button = (Button)sender;
            EncourageMessageTableAdapter encAdapt = new EncourageMessageTableAdapter();

            encAdapt.Insert(button.Attributes["Name"]);
        }
    }
}