﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Windows;

namespace PipeNetworkCost
{
    public class Commands
    {
        private static PaletteSet _psPipeNetwork;

        [CommandMethod("pipeNetworkCost")]
        public static void pipeNetworkCost()
        {
            if (_psPipeNetwork == null)
            {
                _psPipeNetwork = new PaletteSet("Pipe Network Cost");

                _psPipeNetwork.Dock = DockSides.None;
                _psPipeNetwork.DockEnabled = DockSides.Left;

                _psPipeNetwork.Add("Cost Estimation",new PalettePipeNetworkCost());
                _psPipeNetwork.Add("Material Manager", new PaletteMaterialManager());
            }
            _psPipeNetwork.Visible = true;
        }
    }
}
