﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel.Channels;
using System.ServiceModel;

namespace PipeNetworkCost
{
    public partial class PaletteMaterialManager : UserControl
    {
        AecInfoServiceClient aecSvrClnt; // For AEC Database

        public PaletteMaterialManager()
        {
            InitializeComponent();

            System.ServiceModel.Channels.Binding binding = new BasicHttpBinding();

            //// For AEC Database
            EndpointAddress endpointAddressAec = new EndpointAddress("http://adnmonitor.cloudapp.net/AecInfoService.svc?wsdl");
            aecSvrClnt = new AecInfoServiceClient(binding, endpointAddressAec);
        }

        private void uploadButton_Click(object sender, EventArgs e)
        {
            if (matNameBox.Text.Length > 0 &&
                    //matSpecBox.Text.Length > 0 &&
                    //matUnitBox.Text.Length > 0 &&
                    //regionBox.Text.Length > 0 &&
                    costBox.Text.Length > 0)
            {
                float cost = float.Parse(costBox.Text);
                //// Update AEC Database
                aecSvrClnt.UpdateAecMaterialInfo(matNameBox.Text, matSpecBox.Text, matUnitBox.Text, regionBox.Text, cost);
            }
        }

        private void getButton_Click(object sender, EventArgs e)
        {
            if (matNameBox.Text.Length > 0 &&
                 matSpecBox.Text.Length > 0 &&
                 matUnitBox.Text.Length > 0 &&
                 regionBox.Text.Length > 0)
            {
                //// Get the cost per unit from AEC Database
                double cost = aecSvrClnt.GetCostPerUnit(matNameBox.Text, matSpecBox.Text, matUnitBox.Text, regionBox.Text);
                costBox.Text = cost.ToString();
            }
        }
    }
}
