﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using TaskMonitorServiceWebRole.TaskMonitorTableAdapters;
using System.ServiceModel.Activation;
using TaskMonitorServiceWebRole;

namespace TaskMonitorServiceWebRole
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "AecInfoService" in code, svc and config file together.
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class AecInfoService : IAecInfoService
    {
        public double GetCostPerUnit(string matName, string spec, string unit, string region)
        {
            // Implementation of the query of the AEC Material Info table
            double cost = -1;

            MaterialInfoQueryTableAdapter matInfoQueryAdapt = new MaterialInfoQueryTableAdapter();

            matName = matName.ToUpper();
            spec = spec.ToUpper();
            unit = unit.ToUpper();
            region = region.ToUpper();

            TaskMonitorServiceWebRole.TaskMonitor.MaterialInfoQueryDataTable tble = matInfoQueryAdapt.GetMatInfo(matName, spec, unit, region);

            TaskMonitorServiceWebRole.TaskMonitor.MaterialInfoQueryRow row = tble.FirstOrDefault();

            cost = row.CostPerUnit;

            return cost;
        }

        public void UpdateAecMaterialInfo(string matName, string spec, string unit, string region, float cost)
        {
            
            // Obtain the material info table adapter
            MaterialInfoQueryTableAdapter matInfoQueryAdapt = new MaterialInfoQueryTableAdapter();

            matName = matName.ToUpper();
            spec = spec.ToUpper();
            unit = unit.ToUpper();
            region = region.ToUpper();

            // See if the material name and info alreafy ecists
            TaskMonitorServiceWebRole.TaskMonitor.MaterialInfoQueryDataTable tble = matInfoQueryAdapt.GetMatInfo(matName, spec, unit, region);

            foreach (TaskMonitorServiceWebRole.TaskMonitor.MaterialInfoQueryRow row in tble.Rows)
            {
                // Delete the row if it already exists
                matInfoQueryAdapt.Delete(row.matName, row.matSpec, row.matUnit, row.MaterialRegion, row.CostPerUnit, row.EntryID);
            }

            // Update the AEC Material Info table
            matInfoQueryAdapt.Insert(matName, spec, unit, region, cost);

        }

        public void GetCutFillCosts(string location, float? cutVol, float? fillVol, ref float? cutCost, ref float? fillCost)
        {
            // Get the Cut/Fill table adapter
            CutFillDataTableAdapter cutFillAdapt = new CutFillDataTableAdapter();

            TaskMonitor.CutFillDataDataTable tbl = cutFillAdapt.GetCutFillData(location);

            if(null !=cutCost)
                cutCost = 0;
            if(null!=fillCost)
                fillCost=0;

            // Get the cut and fill costs 
            if (tbl.Rows.Count == 1)
            {
                TaskMonitor.CutFillDataRow row = (TaskMonitor.CutFillDataRow)tbl.Rows[0];

                if (null != cutVol && null != cutCost)
                {
                    cutCost = cutVol * row.CutCostPerUnit;
                }

                if (null != fillVol && null != fillCost)
                {
                    fillCost = fillVol * row.FillCostPerUnit;
                }
            }
        }

        public void AddCutFillData(string location, float cutCost, float fillCost)
        {
            // Get the cut/fill table adapter
            CutFillDataTableAdapter cutFillAdapt = new CutFillDataTableAdapter();

            TaskMonitor.CutFillDataDataTable tbl = cutFillAdapt.GetCutFillData(location);

            // If the row already exists, delete it
            foreach (TaskMonitor.CutFillDataRow item in tbl.Rows)
            {
                cutFillAdapt.Delete(item.EntryID, item.Location, item.CutCostPerUnit, item.FillCostPerUnit);
            }

            // Update the cut/fill table
            cutFillAdapt.Insert(location, cutCost, fillCost);
        }
    }
}
