﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace TaskMonitorServiceWebRole
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the interface name "IAecInfoService" in both code and config file together.
    // We are defining a single service interface for the material costs table as well
    // as the cut and fill tables
    [ServiceContract]
    public interface IAecInfoService
    {
        // Query the AEC material information
        [OperationContract]
        double GetCostPerUnit(string matName, string spec, string unit, string region);

        // Update the AEC material information
        [OperationContract]
        void UpdateAecMaterialInfo(string matName, string spec, string unit, string region, float cost);

        // Query the Cut/Fill table
        [OperationContract]
        void GetCutFillCosts(string location,float? cutVol, float? fillVol, ref float? cutCost, ref float? fillCost);

        // Update the Cut/Fill table
        [OperationContract]
        void AddCutFillData(string location, float cutCost, float fillCost);
    }
}
