﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using TaskMonitorServiceWebRole.TaskMonitorTableAdapters;


namespace TaskMonitorServiceWebRole
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the interface name "IService1" in both code and config file together.
    [ServiceContract]
    public interface ITaskMonitorService
    {

        [OperationContract]
        string GetData(int value);

        [OperationContract]
        CompositeType GetDataUsingDataContract(CompositeType composite);

        // This method is used by the client to update the Task List
        // table with the user and entity creation information
        [OperationContract]
        void AddWorkInformation(WorkInformation workInfo);

        // This method is used by the client to find out how many times the "Encourage"
        // button has been clicked for that user
        [OperationContract]
        string GetEncouragement(string usrName);
    }


    // Use a data contract as illustrated in the sample below to add composite types to service operations.
    [DataContract]
    public class CompositeType
    {
        bool boolValue = true;
        string stringValue = "Hello ";

        [DataMember]
        public bool BoolValue
        {
            get { return boolValue; }
            set { boolValue = value; }
        }

        [DataMember]
        public string StringValue
        {
            get { return stringValue; }
            set { stringValue = value; }
        }

        [DataMember]
        public WorkInformation WorkInformationValue
        {
            get { return WorkInformationValue; }
            set { WorkInformationValue = value; }
        }
    }
}
