﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using TaskMonitorServiceWebRole.TaskMonitorTableAdapters;
using TaskMonitorServiceWebRole;
using System.ServiceModel.Activation;

namespace TaskMonitorServiceWebRole
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "MfgInfoService" in code, svc and config file together.
    public class MfgInfoService : IMfgInfoService
    {
        public void DoWork()
        {
        }

        public double GetCostPerUnit(string matName, string spec, string unit, string region)
        {
            double cost = -1;

            // Obtain the Material info table adapter
            MfgMaterialInfoQueryTableAdapter matInfoQueryAdapt = new MfgMaterialInfoQueryTableAdapter();

            matName = matName.ToUpper();
            spec = spec.ToUpper();
            unit = unit.ToUpper();
            region = region.ToUpper();

            // Obtain the row with the material name and the material cost from that row
            TaskMonitor.MfgMaterialInfoQueryDataTable tble = matInfoQueryAdapt.GetMfgMatInfo(matName, spec, unit, region);

            TaskMonitor.MfgMaterialInfoQueryRow row = tble.FirstOrDefault();

            cost = row.CostPerUnit;

            return cost;
        }

        public void UpdateMfgMaterialInfo(string matName, string spec, string unit, string region, float cost)
        {
            // Obtain the Material info table adapter
            MfgMaterialInfoQueryTableAdapter matInfoQueryAdapt = new MfgMaterialInfoQueryTableAdapter();

            matName = matName.ToUpper();
            spec = spec.ToUpper();
            unit = unit.ToUpper();
            region = region.ToUpper();

            TaskMonitor.MfgMaterialInfoQueryDataTable tble = matInfoQueryAdapt.GetMfgMatInfo(matName, spec, unit, region);
            // Check if the material name already exists in the table and delete it
            foreach (TaskMonitor.MfgMaterialInfoQueryRow row in tble.Rows)
            {
                matInfoQueryAdapt.Delete(row.EntryID, row.MaterialName, row.MaterialSpec, row.MaterialUnit, row.MaterialRegion, row.CostPerUnit);
            }

            // Insert the updated information
            matInfoQueryAdapt.Insert(matName, spec, unit, region, cost);

        }
    }
}
