﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using TaskMonitorServiceWebRole.TaskMonitorTableAdapters;
using System.ServiceModel.Activation;
using TaskMonitorServiceWebRole;

namespace TaskMonitorServiceWebRole
{
    // Public structure to store work information
    public class WorkInformation
    {
        public string name;
        public string appname;
        public string entityName;
        public string sessionId;
        public int numEntities;
        public DateTime dateTime;
    }
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class TaskMonotorService : ITaskMonitorService
    {
        public string GetData(int value)
        {
            return string.Format("You entered: {0}", value);
        }

        public CompositeType GetDataUsingDataContract(CompositeType composite)
        {
            if (composite == null)
            {
                throw new ArgumentNullException("composite");
            }
            if (composite.BoolValue)
            {
                composite.StringValue += "Suffix";
            }
            return composite;
        }

        public void AddWorkInformation(WorkInformation workInfo)
        {

            // Obtain the Task list table adapter. The task list table stores information 
            // about the work performed in an AutoCAD session and stores information on
            // entities created.
            TaskListTableAdapter taskListTabltAdapt = new TaskListTableAdapter();
            // Update the table
            taskListTabltAdapt.Insert(workInfo.name, workInfo.appname, workInfo.entityName, workInfo.numEntities, workInfo.sessionId, workInfo.dateTime);
        }

        public string GetEncouragement(string usrName)
        {
            // Obtain the table adapter for the Encourage messages
            EncourageMessageTableAdapter encAdapt = new EncourageMessageTableAdapter();

            TaskMonitor.EncourageMessageDataTable tbl = encAdapt.GetEncData(usrName);

            string retStr = "Nothing";

            int rowCount = tbl.Rows.Count;

            // Depending upon the number of rows per user, the strength of the message
            // changes. These are hard coded messages
            if (tbl.Rows.Count > 0)
            {
                if(rowCount < 2)
                    retStr = "I believe in you!";
                else if(rowCount <4)
                    retStr = "Come on you can do this!";
                else if (rowCount < 6)
                    retStr = "I am watching you!";
                else if (rowCount < 8)
                    retStr = "I'm waiting!!";
                else if (rowCount < 10)
                    retStr = "Is this what I am paying you for?!!";
                else
                    retStr = "We need to talk!";

                foreach (TaskMonitor.EncourageMessageRow item in tbl.Rows)
                {
                    encAdapt.Delete(item.id, item.nm);
                }

            }
            return retStr;
        }

    }
}
